Bug 327 - pam_smbpass broken
pam_smbpass broken
Status: CLOSED FIXED
Product: Samba 3.0
Classification: Unclassified
Component: User/Group Accounts
3.0.0preX
All Linux
: P3 major
: 3.0.0rc2
Assigned To: Gerald (Jerry) Carter
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2003-08-20 00:41 UTC by Ulf Dettmer
Modified: 2005-08-24 10:21 UTC (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ulf Dettmer 2003-08-20 00:41:29 UTC
After an Upgrage from Samba 2.2.8a pam_smbpass does'nt seem to work anymore on 
my SuSE 8.2 box with LDAP / eDirectory 8.7 as passdb backend. This is what I 
tried to do:

# passwd user
Changing password for user.
passwd: Module is unknown

---
/etc/pam.d/passwd:

password required       pam_unix2.so    nullok use_first_pass use_authtok
password required       pam_smbpass.so    use_authtok use_first_pass audit 
migrate smbconf=/etc/samba/smb.conf 

---
extract from /var/log/messages:

Aug 19 13:08:42 herkules passwd[15551]: PAM unable to dlopen(/lib/security/pam_s
mbpass.so)
Aug 19 13:08:42 herkules passwd[15551]: PAM [dlerror: /lib/security/pam_smbpass.
so: undefined symbol: attrib_map_v30]
Aug 19 13:08:42 herkules passwd[15551]: PAM adding faulty module: /lib/security/
pam_smbpass.so
Aug 19 13:08:42 herkules passwd[15551]: User root: Module is unknown

---
options for configure:

./configure --prefix=/usr --exec-prefix=/usr --bindir=/usr/bin --
sbindir=/usr/sbin --libdir=/usr/lib --sysconfdir=/etc --mandir=/usr/man --
infodir=/usr/info --localstatedir=/var/log --with-configdir=/etc/samba --with-
privatedir=/etc/samba --with-lockdir=/var/lock/samba --with-
swatdir=/usr/lib/samba/swat --with-sambabook=/usr/lib/samba/swat/using_samba --
with-codepagedir=/usr/lib/samba/codepages --with-smbwrapper --with-automount --
with-smbmount --with-pam --with-pam_smbpass --with-ldap --with-ldapsam --with-
syslog --with-profiling-data --with-quotas --with-libsmbclient --with-acl-
support --with-sendfile-support --with-winbind --with-ads
Comment 1 Gerald (Jerry) Carter 2003-08-21 14:09:06 UTC
Should be fixed in SAMBA_3_0 cvs

diff -u -r1.468.2.165 Makefile.in
--- Makefile.in 21 Aug 2003 13:04:42 -0000      1.468.2.165
+++ Makefile.in 21 Aug 2003 21:08:35 -0000
@@ -581,7 +581,7 @@
                pam_smbpass/pam_smb_acct.o pam_smbpass/support.o \
                libsmb/smbencrypt.o libsmb/smbdes.o libsmb/nterr.o \
                $(PARAM_OBJ) $(LIB_OBJ) $(PASSDB_OBJ) $(GROUPDB_OBJ) \
-               $(SECRETS_OBJ) $(UBIQX_OBJ)
+               $(SECRETS_OBJ) $(UBIQX_OBJ) $(SMBLDAP_OBJ)

 PAM_SMBPASS_PICOOBJ = $(PAM_SMBPASS_OBJ_0:.o=.po)
Comment 2 Ulf Dettmer 2003-08-25 04:37:10 UTC
Sorry, I am still having almost the same problem than before. The only change 
is the error description in /var/log/messages:

Aug 25 13:28:08 herkules passwd[1012]: PAM unable to dlopen(/lib/security/pam_sm
bpass.so)
Aug 25 13:28:08 herkules passwd[1012]: PAM [dlerror: /lib/security/pam_smbpass.s
o: undefined symbol: unbecome_root]
Aug 25 13:28:08 herkules passwd[1012]: PAM adding faulty module: /lib/security/p
am_smbpass.so
Aug 25 13:28:08 herkules passwd[1012]: User root: Module is unknown

I've tried the patch and the newest Version of Samba 3 from CVS.
Comment 3 Gerald (Jerry) Carter 2003-08-25 12:09:27 UTC
Should be fixed now in the SAMBA_3_0 cvs tree.  The patch was 

diff -u -r1.468.2.167 Makefile.in
--- Makefile.in 22 Aug 2003 18:00:16 -0000      1.468.2.167
+++ Makefile.in 25 Aug 2003 19:08:15 -0000
@@ -579,7 +579,7 @@

 PAM_SMBPASS_OBJ_0 = pam_smbpass/pam_smb_auth.o pam_smbpass/pam_smb_passwd.o \
                pam_smbpass/pam_smb_acct.o pam_smbpass/support.o \
-               libsmb/smbencrypt.o libsmb/smbdes.o libsmb/nterr.o \
+               libsmb/smbencrypt.o libsmb/smbdes.o libsmb/nterr.o lib/dummyroot.o \
                $(PARAM_OBJ) $(LIB_OBJ) $(PASSDB_OBJ) $(GROUPDB_OBJ) \
                $(SECRETS_OBJ) $(UBIQX_OBJ) $(SMBLDAP_OBJ)

@@ -1115,7 +1115,7 @@

 bin/pam_smbpass.@SHLIBEXT@: $(PAM_SMBPASS_PICOOBJ)
        @echo "Linking shared library $@"
-       @$(SHLD) $(LDSHFLAGS) -o $@ $(PAM_SMBPASS_PICOOBJ) -lpam $(DYNEXP)
$(LIBS) -lc
+       @$(SHLD) $(LDSHFLAGS) -o $@ $(PAM_SMBPASS_PICOOBJ) -lpam $(DYNEXP)
$(LIBS) -lc $(LDAPLIBS) $(KRB5LIBS)

 bin/libmsrpc.a: $(LIBMSRPC_PICOBJ)
        @-$(AR) -rc $@ $(LIBMSRPC_PICOBJ)
Comment 4 Ulf Dettmer 2003-08-25 23:30:32 UTC
Sorry, now it's 

Aug 26 08:22:06 herkules passwd[18204]: PAM [dlerror: /lib/security/pam_smbpass.
so: undefined symbol: msrpc_gen]

I did update from CVS ( Makefile.in is new ), "./autogen.sh", "./configure" 
with my bunch of options and "make".
Comment 5 Gerald (Jerry) Carter 2003-08-27 13:38:42 UTC
3rd times the charm right?  I'm about to check in the fix for this.
Loads ok on my system.
Comment 6 Ulf Dettmer 2003-08-27 23:59:28 UTC
I've updated from CVS yet again and now the bug seems to be gone. Thanks !
Comment 7 Gerald (Jerry) Carter 2005-02-07 09:06:02 UTC
originally reported against one of the 3.0.0rc[1-4] releases.
Cleaning up non-production versions.
Comment 8 Gerald (Jerry) Carter 2005-08-24 10:21:47 UTC
sorry for the same, cleaning up the database to prevent unecessary reopens of bugs.